Subject: bug#64360: error: ghc-onetuple: unbound variable

From: Csepp <[email-masked]>
Date: Fri, 07 Jul 2023 16:22:02 +0200

Ludovic Courtès <[email-masked]> writes:

> Hi,
>
> Csepp <[email-masked]> skribis:
>
>> I **finally** managed to finish a guix pull on my netbook by offloading
>> it to my desktop machine, and I tried to build the latest yt-dlp, this
>> is the error I got:
>>
>> ```
>> $ guix shell yt-dlp
>> Backtrace:
>> In srfi/srfi-1.scm:
>>    586:17 19 (map1 (#<<manifest-entry> name: "yt-dlp" version: "202…>))
>> In guix/profiles.scm:
>>   1932:19 18 (_ _)
>> In guix/packages.scm:
>>   1371:17 17 (supported-package? #<package [email-masked] gnu/pa…> …)
>> In guix/memoization.scm:
>>     101:0 16 (_ #<hash-table 23e5c90 0/31> #<package [email-masked]…> …)
>> In guix/packages.scm:
>>   1349:39 15 (_)
>>   1611:16 14 (package->bag _ _ _ #:graft? _)
>>   1715:47 13 (thunk)
>> In gnu/packages/video.scm:
>>   2615:11 12 (native-inputs #<package [email-masked] gnu/packages…>)
>> In guix/packages.scm:
>>   1371:17 11 (supported-package? #<package [email-masked] gnu/pack…> …)
>> In guix/memoization.scm:
>>     101:0 10 (_ #<hash-table 23e5c90 0/31> #<package [email-masked].…> …)
>> In guix/packages.scm:
>>   1349:39  9 (_)
>>   1611:16  8 (package->bag _ _ _ #:graft? _)
>>   1712:48  7 (thunk)
>> In gnu/packages/haskell-xyz.scm:
>>   9121:35  6 (inputs #<package [email-masked] gnu/packages/haskell-…>)
>> In guix/packages.scm:
>>   1424:32  5 (package-closure _ #:system _)
>>   1611:16  4 (package->bag _ _ _ #:graft? _)
>>   1712:48  3 (thunk)
>> In gnu/packages/haskell-web.scm:
>>    943:18  2 (inputs #<package [email-masked] gnu/packages/haskel…>)
>> In ice-9/boot-9.scm:
>>   1685:16  1 (raise-exception _ #:continuable? _)
>>   1685:16  0 (raise-exception _ #:continuable? _)
>>
>> ice-9/boot-9.scm:1685:16: In procedure raise-exception:
>> error: ghc-onetuple: unbound variable
>> ```
>
> Could you share the output of ‘guix describe’?
>
> I can’t reproduce it here:
>
> --8<---------------cut here---------------start------------->8---
> $ guix describe
> Generation 268  Jun 26 2023 00:05:27    (current)
>   guix 269cfe3
>     repository URL: https://git.savannah.gnu.org/git/guix.git
>     branch: master
>     commit: 269cfe341f242c2b5f37774cb9b1e17d9aa68e2c
>   guile 896960d
>     repository URL: https://git.savannah.gnu.org/git/guile.git
>     branch: main
>     commit: 896960dadeba7770ebbad97514ec6c4d7f18212d
>   shepherd d5ed516
>     repository URL: https://git.savannah.gnu.org/git/shepherd.git
>     branch: master
>     commit: d5ed516e736ce473902cc86b5cf4f61f27ebb642
> $ guix shell yt-dlp -- yt-dlp --version
> 2023.06.22
> --8<---------------cut here---------------end--------------->8---
>
> TIA,
> Ludo’.

I'm not on that machine right now, but this is the guix time-machine
invocation that I tried to reproduce it with:

guix time-machine --system=i686-linux \
--commit=e499cb2c12d7f1c6d2f004364c9cc7bdb7e38cd5 \
--channels=$HOME/channels.scm -- time-machine --commit=63660f0febb \
--channels=$HOME/channels.scm --system=i686-linux -- repl

So e499cb2c12d7f1c6d2f004364c9cc7bdb7e38cd5 is the commit I was pulling
from and 63660f0febb is the one I was pulling.

Couldn't reproduce it on my x86_64 machine.

I tried clearing my Guile caches on the i686 machine but that didn't
change anything.
It also happens with a lot of other variables, so much so that guix repl
is also broken.

I have since reconfigured and rebooted the machine too, just to make
sure it wasn't a daemon issue, and that didn't help either.